var items = JSON.parse(FileLib.read("ItemCounter", "tracker.json"));

register('command', function(arg1, arg2, arg3) {
	if(!arg1) {
		ChatLib.chat("&7&oTracking " + items.length + " item" + (items.length == 1 ? "" : "s") + ":")
		
		items.forEach(function(item) {
			var itemCount = 0;
			for(var i = 0; i < Player.getInventory().getSize(); i++) {
				var invItem = Player.getInventory().getStackInSlot(i);
				
				if(ChatLib.removeFormatting(invItem.getName().toLowerCase()) === item['name'].toLowerCase()) {
					itemCount += invItem.getStackSize();
				}
			}
			
			if((item["needed"] - itemCount) > 0) {
				ChatLib.chat("&c&l" + item["name"] + ": &f" + (item["needed"] - itemCount) + " needed!");
			}else{
				var text = new TextComponent("&a&l" + item["name"] + ": &fis done!");
				text.setHover("show_text", "/counter remove " + item["name"].replaceAll(" ", "_"));
				text.setClick("suggest_command", "/counter remove " + item["name"].replaceAll(" ", "_"));
				ChatLib.chat(text);
			}
		});
	}else if(arg1 === "add"){
		if(arg2) {
			arg2 = arg2.replaceAll("_", " ");
			
			var found = false;
			items.forEach(function(item) {
				if(item['name'].toLowerCase() === arg2.toLowerCase()) {
					found = true;
				}
			});
			
			if(found) {
				var text = new TextComponent("&c" + arg2 + " is already made! (Click to remove)");
				text.setHover("show_text", "/counter remove " + arg2);
				text.setClick("suggest_command", "/counter remove " + arg2);
				ChatLib.chat(text);
				return;
			}
			
			if(arg3) {
				ChatLib.chat("&a" + arg2 + " is added!");
				items.push({
					name: arg2,
					needed: (isNumberOrMath(arg3) != null) ? isNumberOrMath(arg3) : 0
				});
				
				FileLib.write("ItemCounter", "tracker.json", JSON.stringify(items, null, 4));
			}else{
				ChatLib.chat("&cPut how many items you'll need as the third argument! (+-/* is supported)");
			}
		}else{
			ChatLib.chat("&cPut the item as a second argument!");
		}
	}else if(arg1 === "remove") {
		if(arg2) {
			arg2 = arg2.replaceAll("_", " ");
			
			var foundAndRemoved = false;
			items.forEach(function(item) {
				if(item['name'].toLowerCase() === arg2.toLowerCase()) {
					ChatLib.chat("&a" + item["name"] + " is removed!");
					removeElement(items, item);
					foundAndRemoved = true;
					
					FileLib.write("ItemCounter", "tracker.json", JSON.stringify(items, null, 4));
				}
			});
			
			if(!foundAndRemoved) {
				ChatLib.chat("&cCouldn't find " + arg2 + "!");
			}
		}else{
			ChatLib.chat("&cPut the item as a second argument!");
		}
	}else if(arg1 === "help") {
		ChatLib.chat("&a&lItem Counter: &fv1.0.0");
		ChatLib.chat("/counter - Shows how much progress on all items");
		ChatLib.chat("/counter help - Shows this menu");
		ChatLib.chat("/counter add <item> <needed> - Adds an item to track (Use _ for space)");
		ChatLib.chat("/counter remove <item> - Removes an item to not track anymore (Use _ for space)");
	}
}).setCommandName('counter');

function isNumberOrMath(number) {
	if(number.includes('+') || number.includes('-') || number.includes('*') || number.includes('/')) {
		return eval(number);
	}
	return parseInt(number);
}

function removeElement(array, elem) {
    var index = array.indexOf(elem);
    if (index > -1) {
        array.splice(index, 1);
    }
}